#include <bits/stdc++.h>
using namespace std;

vector <int> s;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
int n,q;

cin >>n>>q;

vector <int> a(n);
for(int i=0;i<n;i++){
   cin >>a[i];

}
vector <int> s[20];
for(int i=0;i<20;i++)s[i].resize(n);
for(int bit=0;bit<20;bit++){
 s[bit][0]=!((1<<bit)&a[0]);
 for(int i=1;i<n;i++){
    s[bit][i]=s[bit][i-1]+(((1<<bit)&a[i])==0);
 }
}
for(int i=0;i<q;i++){
    int l,r;
    cin >>l>>r;
    l--;
    r--;
    int rez=(1<<20)-1;
    if(l==0){
        for(int bit=0;bit<20;bit++){
        if(s[bit][r]>0){
            rez-=(1<<bit);

        }
        }
    }
    else{
     for(int bit=0;bit<20;bit++){
        if((s[bit][r]-s[bit][l-1])>0){
            rez-=(1<<bit);

        }
        }
    }
    cout <<rez<<endl;
}


}